﻿using Android.App;
using Android.OS;
using Android.Support.V7.App;
using Android.Runtime;
using Android.Widget;
using Android.Content.PM;
using Android.Content;
using Plugin.Permissions;
using System.Threading.Tasks;
using Plugin.Permissions.Abstractions;
using Android.Support.V4.Content;
using Android;
using Android.Views;
using Android.Hardware;
using Android.Graphics;
using Camera = Android.Hardware.Camera;
using static Android.Hardware.Camera;
using System;
using Java.IO;

namespace MyTestShortCut
{
    [Activity(Label = "@string/app_name", Theme = "@style/AppTheme", MainLauncher = true)]
    public class MainActivity : AppCompatActivity, ISurfaceHolderCallback
    {
        private LinearLayout mll;
        private Button button;
        private Camera camera;
        private ISurfaceHolder mHolder;
        private SurfaceView sfv;
        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);
            Xamarin.Essentials.Platform.Init(this, savedInstanceState);
            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.activity_main);

           
           // Android.Content.PM.ShortcutManager shortcutManager = (ShortcutManager)this.GetSystemService(Context.ShortcutService);

            //Open camera permission
            //if (ContextCompat.CheckSelfPermission(this, Manifest.Permission.Camera) != (int)Android.Content.PM.Permission.Granted)
            //{
            //  RequestPermissions(new string[] { Manifest.Permission.Camera }, 0);
            //}


            ////Open storage permission
            //if (ContextCompat.CheckSelfPermission(this, Manifest.Permission.WriteExternalStorage) != (int)Android.Content.PM.Permission.Granted)
            //{
            //  RequestPermissions(new string[] { Manifest.Permission.ReadExternalStorage, Manifest.Permission.WriteExternalStorage }, 0);
            //}


             initView();
            initListener();

    }
        protected override void OnResume()
        {
            base.OnResume();
            if (null == camera)
            {
                camera = getCustomCamera();
                if (mHolder != null)
                {
                    previceCamera(camera, mHolder);
                }

            }

        }

        protected override void OnStop()
        {
            base.OnStop();
            if (null != camera)
            {
                camera.SetPreviewCallback(null);
                camera.StopPreview();
                camera.Release();
                camera = null;
            }

        }
        private void previceCamera(Camera camera, ISurfaceHolder mHolder)
        {
            camera.SetPreviewDisplay(mHolder);
            camera.SetDisplayOrientation(90);
            camera.StartPreview();
        }


        private int FindFrontFacingCamera()
        {
            int cameraId = -1;
            // Search for the front facing camera
          
            int numberOfCameras = Camera.NumberOfCameras;
            for (int i = 0; i < numberOfCameras; i++)
            {
                CameraInfo info = new CameraInfo();
                Camera.GetCameraInfo(i, info);
                if (info.Facing == CameraInfo.CameraFacingFront)
                {
                    //Log.d(DEBUG_TAG, "Camera found");
                    cameraId = i;
                    break;
                }
            }
            return cameraId;
        }

        private Camera getCustomCamera()
        {
            if (null == camera)
            {
                camera = Camera.Open(FindFrontFacingCamera());
                // CameraInfo cameraInfo = new CameraInfo();  

            }
            return camera;

        }

        private void initListener()
        {
            button.Click += Button_Click; 
        }

        private void Button_Click(object sender, System.EventArgs e)
        {
            var parameters = camera.GetParameters();
        
            parameters.PictureFormat = ImageFormatType.Jpeg;
            parameters.SetPreviewSize(480, 720);
            parameters.FocusMode = Camera.Parameters.FocusModeAuto;
            camera.AutoFocus(new MyFocusCallback(camera));
        }

        


        private void initView()
        {
            mll = FindViewById<LinearLayout>(Resource.Id.ll);
            button = FindViewById<Button>(Resource.Id.button1);
            mFloatView();
            mHolder = sfv.Holder;
            mHolder.AddCallback(this);
        }

        public void mFloatView()
        {

            IWindowManager windowManager = GetSystemService(Context.WindowService).JavaCast<IWindowManager>();
            WindowManagerFlags flags = WindowManagerFlags.NotFocusable | WindowManagerFlags.NotTouchModal | WindowManagerFlags.NotTouchable;
            var layoutParams = new WindowManagerLayoutParams(1, 1,
            WindowManagerTypes.SystemAlert,
            flags,
            Format.Rgb888);
            sfv = new SurfaceView(this);
            //mll is LinearLayout
            mll.AddView(sfv, layoutParams);

        }



        public void SurfaceCreated(ISurfaceHolder holder)
        {
            previceCamera(camera, holder);
        }

        public void SurfaceDestroyed(ISurfaceHolder holder)
        {
            if (null != camera)
            {
                camera.SetPreviewCallback(null);
                camera.StopPreview();
                camera.Release();
                camera = null;
            }


        }

        public void SurfaceChanged(ISurfaceHolder holder, [GeneratedEnum] Format format, int width, int height)
        {
            camera.StopPreview();
            previceCamera(camera, holder);
        }

       

        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
        {
            PermissionsImplementation.Current.OnRequestPermissionsResult(requestCode, permissions, grantResults);
            

            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }
    }
}

    public class MyFocusCallback : Java.Lang.Object, IAutoFocusCallback
    {
        Camera mCamera;
        public MyFocusCallback(Camera camera)
        {
            mCamera = camera;
        }
        public void Dispose()
        {
        }

        public void OnAutoFocus(bool success, Camera camera)
        {
        mCamera.TakePicture(null, null, new MyPictureCallback());
        if (success)
            {
               
            }
        }
    }

    public class MyPictureCallback : Java.Lang.Object, IPictureCallback
    {

        public void Dispose()
        {
            throw new NotImplementedException();
        }

        public void OnPictureTaken(byte[] data, Camera camera)
        {
            dealWithCameraData(data);
        }

        private void dealWithCameraData(byte[] data)
        {
            // Here to save your photo
            FileOutputStream fos = null;
        //       string tempStr = System.Environment.GetFolderPath(System.Environment.SpecialFolder.Personal);
        var path = Android.OS.Environment.GetExternalStoragePublicDirectory(Android.OS.Environment.DirectoryDocuments).AbsolutePath;
        string fileName = path + Java.Lang.JavaSystem.CurrentTimeMillis() + ".jpg";
      
           Toast.MakeText(Application.Context,fileName,ToastLength.Short).Show();
            File tempFile = new File(fileName);
            fos = new FileOutputStream(fileName);
            fos.Write(data);
            fos.Close();

        }
    }

   
